<!--
 * @Author: zhp
 * @Date: 2023-01-11 09:24:58
 * @LastEditTime: 2023-07-12 14:30:03
 * @LastEditors: zhp
 * @Description: 
-->
<template>
  <el-card shadow="never" class="aui-card--fill">
    <div class="mod-sys__user">
      <SearchBar :formConfigs="formConfig" ref="ruleForm" @headBtnClick="buttonClick">
        <el-badge :value="5" class="item">
          <el-button type="primary" size="small" @click="conditionSearch">条件搜索</el-button>
        </el-badge>
      </SearchBar>
      <base-table :table-props="tableProps" :page="listQuery.page" :limit="listQuery.limit" :table-data="tableData">
        <method-btn v-if="tableBtn.length" slot="handleBtn" :width="100" label="操作" :method-list="tableBtn"
          @clickBtn="handleClick" />
      </base-table>
      <pagination :limit.sync="listQuery.limit" :page.sync="listQuery.page" :total="listQuery.total"
        @pagination="getDataList" />
      <!-- 弹窗, 新增 / 修改 -->
      <base-dialog :dialogTitle="addOrEditTitle" :dialogVisible="addOrUpdateVisible" @cancel="handleCancel"
        @confirm="handleConfirm" :before-close="handleCancel">
        <transferRecords-add ref="addOrUpdate" @refreshDataList="successSubmit">
        </transferRecords-add>
        <!-- <el-row slot="footer" type="flex" justify="end"> </el-row> -->
      </base-dialog>
      <base-dialog :dialogTitle="searchOrEditTitle" :dialogVisible="searchOrUpdateVisible" @cancel="handleSearchCancel"
        @confirm="handleSearchConfirm" :before-close="handleSearchCancel">
        <transferRecords-search ref="searchOrUpdate" @successSubmit="conditionSearchSubmit">
        </transferRecords-search>
        <el-row slot="footer" type="flex" justify="end">
          <el-col :span="12">
            <el-button size="small" type="primary" plain class="btnTextStyle" @click="handleSearchCancel">
              {{ $t("close") }}
            </el-button>
            <el-button size="small" class="btnTextStyle" type="primary" plain @click="handleSearchReset">{{
              $t("reset")
              }}</el-button>
            <el-button type="primary" size="small" class="btnTextStyle" @click="handleSearchConfirm">
              {{ $t("search") }}
            </el-button>
          </el-col>
        </el-row>
      </base-dialog>
    </div>
  </el-card>
</template>

<script>
import basicPage from "@/mixins/basic-page"
import transferRecordsAdd from "./components/transferRecords-add"
// import AddOrUpdate from './params-add-or-update'
import transferRecordsSearch from "./components/transferRecordsSearch"
// import available from "./components/available.vue"
import basicSearch from "@/mixins/basic-search"
import i18n from "@/i18n"
const tableProps = [
  {
    prop: 'productName',
    label: i18n.t("quality.productName"),
    align: 'center'
  },
  {
    prop: 'supplierName',
    label: i18n.t("quality.supplierName"),
    align: 'center'
  },
  {
    prop: 'transferOutName',
    label: i18n.t("quality.transferOutName"),
    align: 'center'
  },
   {
     prop: 'transferInName',
     label: i18n.t("quality.transferInName"),
    align: 'center'
  },
  {
    prop: 'dataSources',
    label: i18n.t("quality.dataSources"),
    align: 'center'
  },
   {
     prop: 'remark',
     label: i18n.t("quality.remark"),
    align: 'center'
  },
  {
    prop: 'userName',
    label: i18n.t("quality.userName"),
    align: 'center'
  }
]
const tableBtn = [
  {
    type: "edit",
    btnName: "编辑",
  },
  {
    type: "delete",
    btnName: "删除",
  },
];
export default {
  mixins: [basicPage, basicSearch],
  components: {
    transferRecordsSearch,
    transferRecordsAdd
  },
  data() {
    return {
      urlOptions: {
        getDataListURL: "/quality/qmsTransferRecords/page",
        deleteURL: "/quality/qmsTransferRecords",
      },
      tableProps,
      tableBtn,
      searchOrEditTitle: '',
      searchOrUpdateVisible: false,
      formConfig: [
        // {
        //   type: "",
        //   label: i18n.t("params.paramCode"),
        //   placeholder: i18n.t("params.paramCode"),
        //   param: "paramCode",
        // },
        // {
        //   type: "separate",
        // },
        {
          type: "button",
          btnName: "新增",
          name: "add",
          color: "success",
          plain: true
        },
        {
          type: "button",
          btnName: "搜索",
          name: "search",
          color: "primary",
        }
      ],
    };
  },
  deactivated() {
    this.listQuery.startTime =null
    this.listQuery.endTime = null
    this.listQuery.inspectionStage = null
    this.listQuery.inspectionTypeId = null
    this.listQuery.productId = null
    this.listQuery.supplierId = null
  },
  methods: {
    //search-bar点击
    handleProductCancel() {
      this.productOrUpdateVisible = false;
      this.productOrEditTitle = "";
    },
    // handleSearchCancel() {
    //   this.searchOrEditTitle = "";
    //   this.searchOrUpdateVisible = false;
    // },
    conditionSearch() {
      this.searchOrEditTitle = "搜索";
      this.searchOrUpdateVisible = true;
      this.$nextTick(() => {
        this.$refs.searchOrUpdate.init();
      });
    },
    conditionSearchSubmit(dataForm) {
      this.listQuery.startTime = dataForm.timeSlot ? dataForm.timeSlot[0] : ''
      this.listQuery.endTime = dataForm.timeSlot ? dataForm.timeSlot[1] : ''
      this.listQuery.inspectionStage = dataForm.inspectionStage
      this.listQuery.inspectionTypeId = dataForm.inspectionTypeId
      this.listQuery.productId = dataForm.productId
      this.listQuery.supplierId = dataForm.supplierId
      this.listQuery.page = 1;
      this.getDataList();
      this.searchOrUpdateVisible = false;
      // console.log(11111);
      // this.conditionSearchSubmit();
    },
    handleClick(val) {
      console.log(val);
      if (val.type === "delete") {
        this.$confirm(`确定对[名称=${val.data.failureTypeName}]进行删除操作?`, "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        })
          .then(() => {
            this.$http.delete(this.urlOptions.deleteURL, { data: [val.data.id] }).then(({ data }) => {
              if (data && data.code === 0) {
                this.$message({
                  message: "操作成功",
                  type: "success",
                  duration: 1500,
                  onClose: () => {
                    this.getDataList();
                  },
                });
              } else {
                this.$message.error(data.msg);
              }
            });
          })
          .catch(() => { });
      } else if (val.type === 'edit') {
        this.addOrUpdateVisible = true
        this.addOrEditTitle = this.$t('edit')
        this.$nextTick(() => {
          this.$refs.addOrUpdate.init(val.data.id);
        });
      }
    },
    buttonClick(val) {
      switch (val.btnName) {
        case "search":
          // this.listQuery.paramCode = val.paramCode;
          this.listQuery.page = 1;
          this.listQuery.startTime = null
          this.listQuery.endTime = null
          this.listQuery.inspectionStage = null
          this.listQuery.inspectionTypeId = null
          this.listQuery.productId = null
          this.listQuery.supplierId = null
          this.getDataList();
          break;
        case "add":
          this.addOrEditTitle = this.$t('add')
          this.addOrUpdateVisible = true;
          this.addOrUpdateHandle()
          break;
        default:
          console.log(val)
      }
    },
  }
};
</script>
